//=============================================================================
//
//	Copyright (C) Hivertec Inc. 2000-2003	All rights reserved.
//
//	HPCI-PPD534A series for Windows	<< Hippd530.h >> 
//
//	2003/05/23	Ver3.1
//
//=============================================================================
// ----------------------------------------------------------------------------
//	萔`
// ----------------------------------------------------------------------------
#define INVALID_BUS_NUMBER				(-1)		// ȃoXԍ
#define INVALID_DEV_NUMBER				(-1)		// ȃfoCXԍ
#define INVALID_IO_ADDRESS				0xFFFFFFFF	//  I/O AhX
#define INVALID_IRQ_NUMBER				(-1)		//  IRQ ԍ
#define INVALID_HPC_NUMBER				(-1)		// ȊǗԍ
#define INVALID_BOARD_ID				(-1)		// ȃ{[hID

#define ERROR_HPC_ALREADY_OPENED		0x20000001	//  HPCI foCXI[vς
#define ERROR_HPC_INVALID_HANDLE		0x20000002	// HPCI foCXID (nh)
#define ERROR_HPC_ALREADY_WAITING		0x20000003	// Ɋ荞ݑ҂Ԃɂ
#define ERROR_HPC_WAITING_CANCELED		0x20000004	// 荞ݑ҂LZꂽ
#define ERROR_HPC_ILLEGAL_DEVICE		0x20001000	// HPCIfoCXł͂Ȃ

// ----------------------------------------------------------------------------
//	\
// ----------------------------------------------------------------------------
// foCX
typedef struct _HPCDEVICEINFO {
	DWORD			nBusNumber;				// oXԍ
	DWORD			nDeviceNumber;			// foCXԍ
	DWORD			dwIoPortAddress;		// I/O |[gAhX
	DWORD			dwIrqNo;				// IRQ ԍ
	DWORD			dwNumber;				// Ǘԍ(Windows 95ł͖)
	DWORD			dwBoardID;				// {[hID
} HPCDEVICEINFO, * PHPCDEVICEINFO;

// foCX񃊃Xg(foCX擾̂ݎgp)
typedef struct _HPCDEVICEINFOLIST {
	DWORD			nCount;					// ̌
	HPCDEVICEINFO	hpcDeviceInfo[1];		// foCX
} HPCDEVICEINFOLIST, * PHPCDEVICEINFOLIST;

// HPCI foCXID (nh)
typedef DWORD HDEVICEHPC;

// ----------------------------------------------------------------------------
//	萔`
// ----------------------------------------------------------------------------
// foCX񃊃Xg̃oCgTCY
#define GET_HPCDEVICEINFOLIST_SIZE( count ) \
		(sizeof(HPCDEVICEINFOLIST) + (sizeof(HPCDEVICEINFO) * ((count) - 1)))

#define HPC_INVALID_HANDLE ((HDEVICEHPC)INVALID_HANDLE_VALUE)

// ----------------------------------------------------------------------------
//	֐vg^Cv
// ----------------------------------------------------------------------------
#ifdef __cplusplus
extern "C"
{
#endif

// foCX̎擾(F_~[)
__declspec(dllimport) DWORD WINAPI hppd530_GetDeviceCount(WORD dummy);

// foCX̎擾(FfoCX̌AfoCX񃊃Xg̐擪AhX)
__declspec(dllimport) DWORD WINAPI hppd530_GetDeviceInfo(DWORD* pcnDevNum, PHPCDEVICEINFO pHpcDevInfo);

// [{[hIDΉ]  foCXI[v(FfoCX̃AhX)
__declspec(dllimport) HDEVICEHPC WINAPI hppd530_OpenDeviceID(PHPCDEVICEINFO pHpcDevInfo);

// [{[hIDΉ]foCXI[v(FfoCX̃AhX)
__declspec(dllimport) HDEVICEHPC WINAPI hppd530_OpenDevice(PHPCDEVICEINFO pHpcDevInfo);

// foCXN[Y(FHPCI foCXID (nh))
__declspec(dllimport) DWORD WINAPI hppd530_CloseDevice(HDEVICEHPC hDevID);

// R}hobt@(FHPCI foCXID (nh)Ajbgԍ(w)APoCgf[^AWX^XCb`AWX^pf[^(ElSoCg))
__declspec(dllimport) DWORD WINAPI hppd530_CmdWrite(HDEVICEHPC hDevID, WORD AxisNo, BYTE byData, WORD sw, DWORD dwReg);

// 샂[hobt@(FHPCI foCXID (nh)Ajbgԍ(w)APoCgf[^)
__declspec(dllimport) DWORD WINAPI hppd530_DousaWrite(HDEVICEHPC hDevID, WORD AxisNo, BYTE byData);

// 䃂[hobt@(FHPCI foCXID (nh)Ajbgԍ(w)APoCgf[^)
__declspec(dllimport) DWORD WINAPI hppd530_SeigyoWrite(HDEVICEHPC hDevID, WORD AxisNo, BYTE byData);

// Xe[^XPǍ(FHPCI foCXID (nh)Ajbgԍ(w)Af[^i[)
__declspec(dllimport) DWORD WINAPI hppd530_status1Read(HDEVICEHPC hDevID, WORD AxisNo, BYTE * bySts1);

// Xe[^XQǍ(FHPCI foCXID (nh)Ajbgԍ(w)Af[^i[)
__declspec(dllimport) DWORD WINAPI hppd530_status2Read(HDEVICEHPC hDevID, WORD AxisNo, BYTE * bySts2);

// Xe[^XǍ(FHPCI foCXID (nh)Ajbgԍ(w)Af[^i[)
__declspec(dllimport) DWORD WINAPI hppd530_intstatusRead(HDEVICEHPC hDevID, WORD AxisNo, BYTE * byIntSts);

// WX^Ǎ(FHPCI foCXID (nh)Ajbgԍ(w)AWX^ǍR}hw肳ĂAf[^i[(El))
__declspec(dllimport) DWORD WINAPI hppd530_regRead(HDEVICEHPC hDevID, WORD AxisNo, BYTE byData, DWORD * dwReg);

// ELSɐI|[g(FHPCI foCXID (nh)APoCgf[^)
__declspec(dllimport) DWORD WINAPI hppd530_ElstWrite(HDEVICEHPC hDevID, BYTE byData);

// ELSɐI|[gǍ(FHPCI foCXID (nh)Af[^i[)
__declspec(dllimport) DWORD WINAPI hppd530_ElstRead(HDEVICEHPC hDevID, BYTE * byElsData);

// CMPX^[gMRg[|[g(FHPCI foCXID (nh)APoCgf[^)
__declspec(dllimport) DWORD WINAPI hppd530_CmpcWrite(HDEVICEHPC hDevID, BYTE byData);

// CMPX^[gMRg[|[gǍ(FHPCI foCXID (nh)Af[^i[)
__declspec(dllimport) DWORD WINAPI hppd530_CmpcRead(HDEVICEHPC hDevID, BYTE * byCmpData);

#ifdef __cplusplus
}
#endif
